from django.http import HttpResponse
from django.contrib.auth import authenticate
from django.contrib.auth.decorators import login_required
from django.contrib.auth.models import User
from allocation.models import * 
#from allocation.forms import PreferenceForm
from django.forms import modelform_factory
from django.forms import modelformset_factory
from django.views import generic
from django.views.generic.edit import *

from allocation.models import Choice
from allocation.models import Applicant
from django.shortcuts import render, redirect
from django.conf import settings
from django.core.files.storage import FileSystemStorage
from django.contrib.auth import authenticate, login
from django import forms
import csv
from django.urls import reverse_lazy

from django.utils import lru_cache
from django.utils._os import upath
from django.utils.encoding import force_text
from django.utils.functional import lazy
from django.utils.html import format_html
from django.utils.module_loading import import_string
from django.utils.six import string_types, text_type
from django.utils.translation import ugettext as _, ungettext
from django.contrib.auth import *
from alloc import *
from difflib import SequenceMatcher

from django.core.mail import send_mail
from django.core.mail import EmailMessage

from django.core.exceptions import (
    FieldDoesNotExist, ImproperlyConfigured, ValidationError,
)


# @login_required(login_url='/admin/login')
# def index(request): #for /allocation
#   applicant=Applicant.objects.filter(name=request.user.username)[0]
#   # form = PreferenceForm(
#   #   initial={'name': applicant.name , 'rank': applicant.rank}
#   #   )
#   form = ArticleForm(instance=applicant)
#   return render(request, 'allocation/index.html', {'applicant': applicant, 'form': form})
		
# def send_mail(request):
# 	# send_mail('Subject here', 'Here is the message.', settings.EMAIL_HOST_USER,['to@example.com'], fail_silently=False)
# 	email = EmailMessage(
#     'subject_message',
#     'content_message',
#     'sender smtp gmail' +'<codemafia123@gmail.com>',
#     ['codemafia123@gmail.com'],)
# 	email.send()
# 	return HttpResponse("success")

def button_action(request):
    # value = request.POST["prikey"]
    # value = int(value.split('/')[-3])
    # name = Institute.objects.get(pk=value).name
    # allocator(name)
    # return HttpResponse("success")
    institute=request.user.username
    allocator(institute)
    return HttpResponse("success")

def home(request):
    documents = Document.objects.all()
    return render(request, 'core/home.html', { 'documents': documents })
    return HttpResponse("On home")

def choice_make(request):
    if request.method == "POST":
        csvfile = request.FILES['myfile']
        file_data = csvfile.read().decode("utf-8")
        lines = file_data.split("\n")
        user_name = request.user.username
        institute = Institute.objects.filter(name=user_name)[0]
        for line in lines:
            line = line.split(',')
            number = len(line)
            if number != 2:
            	return HttpResponse("Incorrect data format in uploaded .csv file.")
            existing_no = institute.choices.filter(choice_name=line[0])
            if existing_no.count() != 0:
            	return HttpResponse(".csv file has choices that already exists")
        for line in lines:
            line =  line.split(',')
            tmp =  institute.choices.create(choice_name=line[0],capacity=line[1])
            tmp.save()
            # tmp = Choice.objects.create(choice_name=line[0],capacity=line[1])
        return HttpResponse("successful")
    return HttpResponse("Error")


@lru_cache.lru_cache(maxsize=None)
def get_default_password_validators():
    return get_password_validators(settings.AUTH_PASSWORD_VALIDATORS)

def get_password_validators(validator_config):
    validators = []
    for validator in validator_config:
        try:
            klass = import_string(validator['NAME'])
        except ImportError:
            msg = "The module in NAME could not be imported: %s. Check your AUTH_PASSWORD_VALIDATORS setting."
            raise ImproperlyConfigured(msg % validator['NAME'])
        validators.append(klass(**validator.get('OPTIONS', {})))

    return validators


def applicant_make(request):
    if request.method == "POST":
        csvfile = request.FILES['myfile']
        file_data = csvfile.read().decode("utf-8")
        user_name = request.user.username
        institute = Institute.objects.filter(name=user_name)[0]
        lines = file_data.split("\n")
        for line in lines:
        	line = line.split(',')
        	number = len(line)
        	if number != 4:
        		return HttpResponse("Incorrect data format in uploaded .csv file")
        	existing_no_app = institute.applicants.filter(name = line[0],rank = line[1])
        	existing_no_user = User.objects.filter(username=line[0],email=line[2],password=line[3])
        	if existing_no_app.count() != 0:
        		return HttpResponse(".csv files has applicants that already exists")
        	if existing_no_user.count() != 0:
        		return HttpResponse("user with same username,password and email-id already exists")
        	errors = []
       		password_validators = get_default_password_validators()
       		for validator in password_validators:
       			try:
        			validator.validate(line[3])
        		except ValidationError as error:
        			errors.append(error)
        	if errors:
        		return HttpResponse("Invalid password given in .csv file")	
        	# if validate_password(line[4]) != None:
        	# 	return HttpResponse("Invalid password given in .csv file")
        for line in lines:
            line = line.split(',')
            tmp = institute.applicants.create(name = line[0],rank = line[1])
            tmp.save()
            user = User.objects.create_user(username=line[0],email=line[2],password=line[3])
            user.is_staff = True
            user.save()
        return HttpResponse("successful")
    return HttpResponse("Error")


AppFormset = modelformset_factory(Application,fields=("choice", "priority" ), extra=5)

@login_required(login_url='/admin/login')
def index(request): #for /allocation
    applicant=Applicant.objects.filter(name=request.user.username)[0]
    # form1 = modelform_factory(Applicant, fields=("name", "rank" ))
    formset = AppFormset(queryset=Application.objects.filter(applicant=applicant),)
    return render(request, 'allocation/index.html', {'applicant': applicant,  'formset': formset,})


# def submit(request):
#   if request.method == 'POST':
#       formset = AppFormset(request.POST)
#       if formset.is_valid():
#           for form in formset:
#               if form.is_valid():
#                   cd = f.cleaned_data
#                   application.applicant=cd.get('applicant')
#                   application.choice=cd.get('choice')
#                   application.priority=cd.get('priority')
#                   application.save()
#       else:
#           return HttpResponse('error')


def submit(request):
    if request.method == 'POST':
        formset = AppFormset(request.POST)
        instances = formset.save()
        return HttpResponse("successful")

@login_required(login_url='/admin/login')
def admin1(request):
    institute=Institute.objects.filter(name=request.user.username)[0]
    return render(request, 'allocation/admin1.html',{'institute': institute})


class ChoiceListView(generic.ListView):
    model = Choice
    def get_context_data(self, **kwargs):
        institute=Institute.objects.filter(name=self.request.user.username)[0]
        context = super(ChoiceListView, self).get_context_data(**kwargs)
        context['institute'] = institute
        return context
    def get_queryset(self):
        institute=Institute.objects.filter(name=self.request.user.username)[0]
        return Choice.objects.filter(institute__name=institute.name)

class ApplicantListView(generic.ListView):
    model = Applicant
    def get_context_data(self, **kwargs):
        institute=Institute.objects.filter(name=self.request.user.username)[0]
        context = super(ApplicantListView, self).get_context_data(**kwargs)
        context['institute'] = institute
        return context
    def get_queryset(self):
        institute=Institute.objects.filter(name=self.request.user.username)[0]
        return Applicant.objects.filter(institute__name=institute.name)

class ChoiceDetailView(generic.DetailView):
    model = Choice
    def get_context_data(self, **kwargs):
        institute=Institute.objects.filter(name=self.request.user.username)[0]
        context = super(ChoiceDetailView, self).get_context_data(**kwargs)
        context['institute'] = institute
        return context

class ApplicantDetailView(generic.DetailView):
    model = Applicant
    def get_context_data(self, **kwargs):
        institute=Institute.objects.filter(name=self.request.user.username)[0]
        context = super(ApplicantDetailView, self).get_context_data(**kwargs)
        context['institute'] = institute
        return context

class ChoiceCreateView(CreateView):
    model = Choice
    fields = ['choice_name', 'capacity', 'institute']

class ChoiceUpdate(UpdateView):
    model = Choice
    fields = ['choice_name','capacity']
    template_name_suffix = '_update'
    success_url = 'allocation:choice_list'

class ChoiceDelete(DeleteView):
    model = Choice
    success_url = reverse_lazy('allocation:choice_list')



